/**
 * 排行榜分类视图
 */
DGC.View.BoardCategory =  $.inherits(DGC.View, {

    baseId:'boardcategory-view',

    /**
     * 别名
     */
    alias: 'BoardCategory',

    /**
     * 根视图
     */
    isSub: false,

    game : undefined,

    player: undefined,

    boardList: undefined,

    /**
     * 视图初始化函数
     */
    viewReady: function(){

        /**
         * 子模块需要的数据HTML模板
         * @type
         */
        this.viewTpl = {
            BOARD:'#board-tpl'
        };

        var gameName = window.sdk.isOffline ? window.sdk.game_name : (this.game != null ? this.game.name : window.sdk.game.name);

        //游戏名称显示
        this.setTitle($.format(resName.A_TITLE_BOARD, [ gameName ] ));

        //this.queryGameBoard();
        //查询数据/获得模板/渲染HTML/绑定事件
        var me = this,
            model = me.action.model;

        //直接渲染
        if(this.boardList){
            this.renderBoardList();
        //查询排行列表
        }else{
            model['hs'].queryLeaderBoradList(window.sdk.game.id);
        }

        //离线显示重登陆按钮
        if(window.sdk.isOffline){
            this.bindReloginBtn();
        }else{
            //广告显示
            this.adPlugin = new DGC.ViewPlugin.SildeAds(this);
            this.adPlugin.start();
        }

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_LEADERBOARD_INDEX);

    },

    /**
     * 离线重登录按钮绑定
     */
    bindReloginBtn : function(){
         $("#offline-relogin").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this } , function(event){
                DGC.ActionUtil.offlineRelogin();
            });

         $("#bc-offline-tip").show();
    },

    renderBoardList: function(optionBoards){
        var me  = this,
            listWrap = $("#board-list");

        //存在排行列表参数
        if(optionBoards){
            this.boardList = optionBoards;
        }

        //防止排行榜为null
        this.boardList = this.boardList || [];

        //排行模式数
        $("#bc-board-num").html($.format(resName.TEXT_BOARDCATEGORY_TOTALS,[this.boardList.length]));

        if(this.boardList.length > 0 ){
            listWrap.html(this.renderByTpl(me.viewTpl.BOARD, this.boardList));
            listWrap.find('.list-item')
                    .bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                    .bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                    .bind('tap',{context : this} ,this.showBoardDetail);

           //延迟加载图片
           this.loadImages(this.getDelayIcons(this.boardList), function(img, data){
                var wrap = $(".list-item[data-board='"+ data.identifier +"']");
                wrap.find(".board-defaut-icon").replaceWith('<img src="' + img.src + '"/><div class="mask"></div>')
           });

        }else{
            listWrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_DASHBOARD_EMPTY_MODEL));
        }
    },

    /**
     * 获取延迟加载图标
     */
    getDelayIcons : function(boards){
        var delays = [];

        //delayIcons
        for (var i = 0; i < boards.length; i++) {
            var board = boards[i];
            if(!$.isEmpty(board.icon_url)){
                delays.push({
                    url: board.icon_url,
                    identifier: board.identifier
                });
            }
        };

        return delays;
    },

    /**
     * 显示该排行榜的详细信息
     */
    showBoardDetail : function(event){
        var identifier = $(this).data("board"),
            context =  event.data.context,
            clickBoard;
        //找到点击Board对象
        for (var i = 0; i < context.boardList.length; i++) {
            clickBoard = context.boardList[i];
            if(clickBoard.identifier == identifier){
                break;
            }
        };

        //如果排行榜为离线状态，进入离线排行榜，否则进入在线排行榜
        if(window.sdk.isOffline){
            context.action.setView('OfflineBoard',{
                leaderBoard: clickBoard,
                boardList: context.boardList,
                isSub: true
            });
        }else{
            context.action.setView('Dashboard',{
                game: context.game,
                player: context.player,
                leaderBoard: clickBoard,
                isSub: true
            });
        }
    },

    /**
     * 销毁广告
     */
    onDestory: function(){
        if(this.adPlugin){
            this.adPlugin.destory();
            this.adPlugin = null;
        }

    }

});
